<template>
  <b-form-group
    :class="mandatory === true ? 'mandatory' : ''"
    :label-for="labelFor"
    :label-cols-sm="labelColsSm"
    :label-align-sm="labelAlignSm"
  >
    <b-skeleton-wrapper :loading="isLoading">
      <template #loading>
        <b-skeleton :type="type" animation="fade"></b-skeleton>
      </template>
      <slot />
    </b-skeleton-wrapper>

    <template #label>
      <span>{{ label }}</span>
      <div class="d-inline-flex ml-1" v-if="info">
        <InfoOutlineIcon :id="labelFor" class="icon-tiny" :title="$t('info')" />
        <b-popover
          over
          :target="labelFor"
          triggers="hover focus"
          placement="bottom"
        >
          <slot name="popover" />
        </b-popover>
      </div>
    </template>
  </b-form-group>
</template>

<script lang="ts">
import {
  FormGroupPlugin,
  BSkeletonWrapper,
  BSkeleton,
} from "bootstrap-vue";
import Vue from "vue";
import InfoOutlineIcon from "vue-material-design-icons/InformationOutline.vue";
Vue.use(FormGroupPlugin);
Vue.component("b-skeleton-wrapper", BSkeletonWrapper);
Vue.component("b-skeleton", BSkeleton);

export default Vue.extend({
  name: "CoscineFormGroup",
  components: {
    InfoOutlineIcon,
  },
  props: {
    info: {
      default: false,
      type: Boolean,
    },
    isLoading: {
      default: false,
      type: Boolean,
    },
    mandatory: {
      default: false,
      type: Boolean,
    },
    labelFor: {
      default: null,
      type: String,
    },
    label: {
      default: null,
      type: String,
    },
    type: {
      default: "text",
      type: String,
    },
    labelColsSm: {
      default: "3",
      type: String,
    },
    labelAlignSm: {
      default: "right",
      type: String,
    },
  },
});
</script>
<style>
.col-form-label {
  font-weight: bold;
}
.mandatory .col-form-label:after {
  content: " *";
  color: #a70619;
}
</style>
